<template>
  <el-dialog title="Edit user" :visible.sync="dialogVisible" @close="cancelForm()">
    <el-form :model="user" :rules="rules" status-icon>
      <el-form-item label="Role" prop="role" required :error="errors.role">
        <el-select v-model="user.role" style="width: 100%">
          <el-option label="User" value="user"></el-option>
          <el-option label="Agent" value="agent"></el-option>
          <el-option label="Manager" value="manager"></el-option>
          <el-option label="Administrator" value="administrator"></el-option>
        </el-select>
      </el-form-item>
    </el-form>

    <span slot="footer" class="dialog-footer">
      <el-button @click="cancelForm()">Cancel</el-button>
      <el-button @click="deleteUser()" type="danger">Delete</el-button>
      <el-button type="primary" @click="submitForm()">Save</el-button>
    </span>
  </el-dialog>
</template>

<script>
import UserQuery from '../../../graphql/queries/user'
import UpdateUserMutation from '../../../graphql/mutations/update_user'
import DeleteUserMutation from '../../../graphql/mutations/delete_user'

export default {
  apollo: {
    user: {
      query: UserQuery,
      variables () { return { id: this.$route.params.id } },
      update({ user }) {
        return { id: user.id, role: user.role } }
    }
  },
  data() {
    return {
      dialogVisible: true,
      user: {
        id: null,
        role: 'user'
      },
      rules: { },
      errors: {
        role: ''
      }
    }
  },

  mounted () {
    this.$apollo.queries.user.refetch()
  },

  methods: {
    submitForm() {
      this.$apollo.mutate({
        mutation: UpdateUserMutation,
        variables: { user: this.$data.user },
        update: (store, { data: { updateUser } }) => {
          if(updateUser.success) {
            this.$message.success('User update successfully')
            this.$data.dialogVisible = false
            this.$router.push('/admin/users')
          }
          else{
            this.$message.error('Failed to update user')
            updateUser.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    },
    cancelForm() {
      this.$data.dialogVisible = false
      this.$router.push('/admin/users')
    },
    deleteUser() {
      this.$confirm('Are you sure you want to delete this user?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(() => {
        this.$apollo.mutate({
          mutation: DeleteUserMutation,
          variables: { user: { id: this.$route.params.id } },
          update: (store, { data: { deleteUser } }) => {
            if(deleteUser.success) {
              this.$message.success('User deleted successfully')
              this.$data.dialogVisible = false
              this.$router.push('/admin/users')
            }
            else
              this.$message.error('Failed to delete user')
          }
        })
      })
    }
  }
}
</script>
